// 2005-03-20 programmeerimisvistlus
// lesanne: VALGUSFOORID
// Autor: Martin Pettai
// Testitud: GCC 3.2 / MinGW

#include <cstdio>

const int MAXN = 500000;

unsigned vaheaeg[MAXN]; // aeg valgusfooride i ja i+1 vahelise tee lbimiseks
unsigned vas[MAXN], par[MAXN]; // foori i juurde judmise aeg vasakult ja paremalt

int main() {
   FILE *sis = fopen("foor.sis", "rt");
   FILE *val = fopen("foor.val", "wt");
   int N;
   unsigned K;
   fscanf(sis, "%d %u", &N, &K);
   for (int i = 0; i < N-1; i++)
      fscanf(sis, "%u", &vaheaeg[i]);

   // vasakult paremale
   unsigned aeg = 0;
   for (int i = 0; i < N; i++) {
      vas[i] = aeg;
      if (i < N-1) {
         aeg += vaheaeg[i];
         aeg %= 2*K;
      }
   }

   // paremalt vasakule
   aeg = 0;
   for (int i = N-1; i >= 0; i--) {
      par[i] = aeg;
      if (i > 0) {
         aeg += vaheaeg[i-1];
         aeg %= 2*K;
      }
   }

   // fooride faasid
   for (int i = 0; i < N; i++) {
      int vahe;

      // lihtsalt (par[i]-vas[i]) % (2*K) ei saa arvutada,
      // mrgita arvudes ei saa hoida negatiivset vahetulemust
      if (par[i] >= vas[i])
         vahe = par[i] - vas[i];
      else
         vahe = par[i] + 2*K - vas[i];

      if (vahe <= K)
         fprintf(val, "%u\n", vas[i]);
      else
         fprintf(val, "%u\n", par[i]);
   }

   fprintf(val, "0 0\n");
   fclose(sis);
   fclose(val);
   return 0;
}
