#include <cstdio>
#include <cstdlib>

const int MAXN = 500000;

FILE *sis, *val;

void success() {
   fputs("Korras\n", stderr);
   exit(0);
}

void failure(const char *s) {
   fputs("Vljundfail ei ole korrektne: ", stderr);
   fputs(s, stderr);
   fputc('\n', stderr);
   exit(1);
}

unsigned K;

int getint() {
   int x;
   int ret = fscanf(val, "%d", &x);
   if (ret==0)
      failure("Tisarvu lugemine ebannestus");
   else if (ret==EOF)
      failure("Ootamatu faili lpp");
   else if (x<0 || x>=2*K)
      failure("Tisarv ei ole poolligus [0, 2K)");
   return x;
}

int N;

unsigned vaheaeg[MAXN]; // aeg 2 valgusfoori vahelise tee lbimiseks
int rohalgus[MAXN];
int aeg1, aeg2;

void kontrolli() {
   unsigned aeg = aeg1;
   fputs("Kontrollime liikumist vasakult paremale\n", stderr);
   for (int i=0; i<N; i++) {
      unsigned ra = rohalgus[i];
      unsigned a = (aeg>=ra)?aeg-ra:(aeg+2*K-ra);
      if (a > K) {
         char s[256];
         sprintf(s, "Valgusfoor %d lbitakse punase tulega (%u s prast rohelise sttimist)", i+1, a);
         failure(s);
      }
      if (i<N-1) {
         aeg += vaheaeg[i];
         aeg %= 2*K;
      }
   }

   aeg = aeg2;
   fputs("Kontrollime liikumist paremalt vasakule\n", stderr);
   for (int i=N-1; i>=0; i--) {
      unsigned ra = rohalgus[i];
      unsigned a = (aeg>=ra)?aeg-ra:(aeg+2*K-ra);
      if (a > K) {
         char s[256];
         sprintf(s, "Valgusfoor %d lbitakse punase tulega (%u s prast rohelise sttimist)", i+1, a);
         failure(s);
      }
      if (i>0) {
         aeg += vaheaeg[i-1];
         aeg %= 2*K;
      }
   }

   success();
}

int main(int argc, char **argv) {
   if (argc<3) {
      fprintf(stderr, "Kasutage: %s sisendfail vljundfail\n", argv[0]);
      fprintf(stderr, "Kontrollib kas vljundfail on korrektne lahendus antud sisendfailile\n");
      return 16;
   }

   sis = fopen(argv[1], "r");
   if (sis == NULL) {
      fprintf(stderr, "Ei saa avada sisendfaili\n");
      return 16;
   }
   val = fopen(argv[2], "r");
   if (val == NULL) {
      fprintf(stderr, "Ei saa avada vljundfaili\n");
      return 16;
   }

   fscanf(sis, "%d %u", &N, &K);
   for (int i=0; i<N-1; i++)
      fscanf(sis, "%u", &vaheaeg[i]);

   for (int i=0; i<N; i++)
      rohalgus[i] = getint();

   aeg1 = getint();
   aeg2 = getint();

   kontrolli();

   return 0;
}
