{ 2005-03-20 programmeerimisvistlus                                        }
{ lesanne: SNADE LAHUTAMINE                                               }
{ Autor: Avo Muromgi                                                       }
{ Testitud: FPC 1.0.10 / Win32                                              }

{ Optimeeritud variantide lbivaatus }

const
 INPUT_FILE = 'sona.sis';
 OUTPUT_FILE = 'sona.val';
 MAX_N = 21;
 MAX_LENGTH = 250;

type
 //struktuur iga sna iga kikide erinevate thtede arvu ja sna pikkuse hoidmiseks
 TWord = record
    c : array ['A'..'Z'] of integer;
    l : integer;
end;

//funktsioon, mis teisendab stringi eelpool defineeritud andmetbiks
function StrToTWord(const s : string) : TWord;
var
 ch : char;
 i : integer;
 result : TWord;
begin
    for ch := 'A' to 'Z' do
        result.c[ch] := 0;
    result.l := length(s);
    for i := 1 to result.l do
        Inc(result.c[s[i]]);
    StrToTWord := result;
end;

var
 inf, outf : text;                          //sisend- ja vljundfail
 n : integer;                               //snade arv
 lengthC : integer;                         //thtede arv vastuses
 words, stack : array [0..MAX_N] of TWord;  //snade nimekiri, stack'i kasutatakse rekursioonil tulemuse hoidmiseks
 maxDec : array [1..MAX_N] of integer;      //nitab, kui palju annab i..MAX_N sna maha lahutades sna pikkust vhendada

procedure ReadInput();
var
 b : boolean;
 ch : char;
 i, j : integer;
 s : string;
begin
    Assign(inf, INPUT_FILE); Reset(inf);
    Readln(inf, s);
    words[0] := StrToTWord(s);
    Readln(inf, n);
    j := 0;
    for i := 1 to n do begin
        Readln(inf, s);
        if s = '' then
            continue;
        words[i] := StrToTWord(s);
        b := false;
        for ch := 'A' to 'Z' do
            if words[i].c[ch] > words[0].c[ch] then begin
                b := true;
                break;
            end;
        if b then
            continue;
        Inc(j);
        words[j] := words[i];
    end;
    Close(inf);
    n := j;
end;

//lahutab stackis olevast esialgsest esimesest snest jrelejnud snest d-nda sna
function take(const d : integer) : boolean;
var ch : char;
begin
    take := false;
    for ch := 'A' to 'Z' do begin
        Inc(stack[d].c[ch], words[d].c[ch]);
        if stack[d].c[ch] > words[0].c[ch] then
            exit;
    end;
    stack[d].l := stack[d - 1].l + words[d].l;
    take := true;
end;

//phittegija, rekursiivne otsing
procedure FindC(const d : integer);
begin
    if d > n then begin
        if words[0].l - stack[d - 1].l < lengthC then
            lengthC := words[0].l - stack[d - 1].l;
        Exit;
    end;
    stack[d] := stack[d - 1];
    if words[0].l - stack[d].l - maxDec[d] >= lengthC then
        Exit;
    //kigepealt, vaatab, mis saab siis, kui sna lahutada maha
    //mahalahutud varianti vaatame enne, kuna see phjustab rohkem likamisi
    if take(d) then
        FindC(d + 1);
    stack[d] := stack[d - 1];
    //ja mis saab siis, kui seda ei tehta
    FindC(d + 1);
end;

//sorteerib sisendis olnud snad pikkuse mittekasvavas jrjekorras
procedure SortWords();
var 
 i, j : integer;
 w : TWord;
begin
    for i := 1 to n - 1 do
        for j := i + 1 to n do
            if words[i].l > words[j].l then begin
                w := words[i];
                words[i] := words[j];
                words[j] := w;
            end;
end;

procedure ProcessInput();
var i : integer;
begin
    SortWords();
    stack[0] := StrToTWord('');
    maxDec[n] := words[n].l;
    for i := n - 1 downto 1 do
        maxDec[i] := maxDec[i + 1] + words[i].l;
    FindC(1);
end;

procedure WriteOutput();
begin
    Assign(outf, OUTPUT_FILE); Rewrite(outf);
    Writeln(outf, lengthC);
    Close(outf);
end;

begin
    lengthC := MAX_LENGTH + 1;
    ReadInput();
    ProcessInput();
    WriteOutput();
end.
